Unit DE42RP_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure DE42RP(M :Integer; IORDER :Integer; ALP :Real;
                var DF :Array of Real; var DY :Array of Real);

implementation

procedure DE42RP(M :Integer; IORDER :Integer; ALP :Real;
                var DF :Array of Real; var DY :Array of Real);
var
I,J,L,L1,J1 :Integer;
B,D1,ALP2,ALP3,ALP4,R,E,AJ,B1 :Real;
C :Array [0..9] of Real;
D :Array [0..4] of Real;
const
//SYS053 :Real = 1.7e308;
SYS053 :Real = 1.7e38;
A1 :Real = 0.3333333333333333e0;
A2 :Real = 1.571428571428571e0;
A3 :Real = 0.5833333333333333e0;
A4 :Real = 0.03333333333333333e0;
A5 :Real = 0.008333333333333333e0;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_91,_10,_11,_12,_13;
begin
if ( ALP = 1.0 ) 
 then goto _13;
if ( ALP = 0.5 ) 
 then goto _11;
if ( ALP = 2.0 ) 
 then goto _10;
B := 1.0/ALP;
ALP2 := ALP*ALP;
ALP3 := ALP2*ALP;
ALP4 := ALP3*ALP;
D1 := (ALP-1.0);
C[0] := ALP*ALP*ALP;
D[0] := -6.0*D1;
D[1] := 2.0*D1*(ALP+1.0);
C[1] := -C[0]*(ALP-1.0)*0.5;
C[2] := C[0]*ALP;
D[2] := 0.5*D1*(ALP2+ALP-1.0);
C[3] := -C[1]*(ALP-2.0)*A1;
C[4] := -C[2]*(ALP-1.0);
C[5] := C[2]*ALP;
D[3] := A4*D1*(8.0*ALP3+8.0*ALP2-12.0*ALP+3.0);
C[6] := -C[3]*(ALP-3.0)*0.25;
C[7] := -C[4]*(ALP-A2)*A3;
C[8] := -C[5]*(ALP-1.0)*1.5;
C[9] := C[5]*ALP;
D[4] := A5*D1*(21.0*ALP4+21.0*ALP3-39.0*ALP2+16.0*ALP-2.0);
_1:
for I:=1 to M do
 begin
  DF[(I-1)+0*M] := DF[(I-1)+0*M]*ALP2;
  for J:=2 to IORDER do
   begin
    R := 0;
    for L:=J to IORDER do
     begin
      L1 := (L-1)*(L-2) div 2+J-1;
      R := R+DF[(I-1)+(L-1)*M]*C[L1-1];
_2:
     end;
    DF[(I-1)+(J-1)*M] := R;
_3:
   end;
_4:
 end;
E := 10.0/SYS053;
for I:=1 to M do
 begin
  DY[I-1] := ALP*DY[I-1];
_5:
 end;
AJ := 1.0;
B1 := 1.0;
J1 := 1;
for J:=1 to IORDER do
 begin
  AJ := AJ*ALP;
  if ( Abs(AJ) < E )
   then goto _7;
  B1 := B1*B;
  J1 := J+1;
  R := B1*D[J-1];
  for I:=1 to M do
   begin
_6:
    DY[I-1] := DY[I-1]+R*DF[(I-1)+(J-1)*M];
   end;
  goto _91;
_7:
  R := B1*D[J-1];
  for I:=1 to M do
   begin
    R := R*DF[(I-1)+(J-1)*M];
    for L:=J1 to J do
     begin
_8:
      R := R*B;
     end;
    DY[I-1] := DY[I-1]+R;
_9:
   end;
_91:
 end;
goto _13;
_10:
C[0] := 8.0;
C[1] := -4.0;
C[2] := 16.0;
C[3] := 0.0;
C[4] := -16.0;
C[5] := 32.0;
C[6] := 0.0;
C[7] := 4.0;
C[8] := -48.0;
C[9] := 64.0;
B := 0.5;
D1 := 1.0;
D[0] := -6.0;
D[1] := 6.0;
D[2] := 2.5;
D[3] := 2.5;
D[4] := 3.15;
ALP2 := 4.0;
ALP3 := 8.0;
ALP4 := 16.0;
goto _1;
_11:
for I:=1 to M do
 begin
  DF[(I-1)+4*M] := DF[(I-1)+4*M]*0.015625;
  DF[(I-1)+3*M] := DF[(I-1)+3*M]*0.03125+DF[(I-1)+4*M]*1.5;
  DF[(I-1)+2*M] := DF[(I-1)+2*M]*0.0625+DF[(I-1)+3*M]-DF[(I-1)+4*M]*0.25;
  DF[(I-1)+1*M] := DF[(I-1)+1*M]*0.125+DF[(I-1)+2*M]*0.5;
  DF[(I-1)+0*M] := DF[(I-1)+0*M]*0.25;
  DY[I-1] := 0.5*(DY[I-1]+12.0*(DF[(I-1)+0*M]-DF[(I-1)+1*M])+DF[(I-1)+2*M]-0.05*
    DF[(I-1)+4*M]);
_12:
 end;
_13:
end;

end.
